#include "filereader.h"

FileReader::FileReader(){}

FileReader::FileReader(string filename){
  int pathend=filename.rfind('/');
  if(pathend!=0)
    path=filename.substr(0,pathend+1);
  ifstream *in=new ifstream;in->open(filename.c_str());
  files.push(in);
  manageStack();
}

string FileReader::nextLine(){
  string stmt=getStatement();
  while(stmt[0]=='<' && stmt[stmt.length()-1]=='>')
    {
      stmt.erase(0,1);stmt.erase(stmt.length()-1,1); // Drop the angle brackets
      string fname=path+stmt;
      ifstream *in=new ifstream;in->open(fname.c_str());
      if(!in->fail() && !in->eof())files.push(in);
      else cout<<"Cannot open file: "<<stmt<<'\n';
      stmt=getStatement();
    }
  return stmt;
 }

// Get the next non-commented statement 
string FileReader::getStatement(){
  string line_commented,line;

  while(line.length()==0)
    {
      getline(*(files.top()),line_commented,'\n');
      line.reserve(line_commented.length());
      for(int n=0;n!=line_commented.length();n++)
	if(line_commented[n]!='#')line+=line_commented[n];
	else break;
      if(line.length()!=0)
	{
	  while(line[0]==' ' || line[0]=='\t')line.erase(0,1);
	  while(line[line.length()-1]==' ' || line[line.length()-1]=='\t')line.erase(line.length()-1,1);
	}
      manageStack();
    }
  return line;
}

void FileReader::manageStack(){
  while(!files.empty() && (files.top()->fail() || files.top()->eof()))
    {
      files.top()->close();
      delete files.top();
      files.pop();
    }
}

bool FileReader::eof() const{
  return files.empty();
}
